
#ifndef DISPLAY_H_
#define DISPLAY_H_

#include "stm32f30x.h"



// Port numbers: 0=A, 1=B, 2=C, 3=D, 4=E, 5=F, 6=G, ...
#define DISPLAY_PORT_NUMBER               (3)
#define DISPLAY_PIN_NUMBER_MIN            (0)
#define DISPLAY_PINS					   (12)


#define DISPLAY_GPIOx(_N)                 ((GPIO_TypeDef *)(GPIOA_BASE + (GPIOB_BASE-GPIOA_BASE)*(_N)))
#define DISPLAY_PIN_MASK(_N)              (1 << (_N))
#define DISPLAY_RCC_MASKx(_N)             (RCC_AHBPeriph_GPIOA << (_N))

#define DISPLAY_DIGITS 				(4)

typedef struct {
	uint16_t last_digit;
	uint8_t  segments[DISPLAY_DIGITS];
} DisplayState;

// ----------------------------------------------------------------------------
void display_init(DisplayState *state);

void display_show(DisplayState *state, uint16_t number, uint16_t decimal_point);

void display_clear(DisplayState *state);

void display_refresh(DisplayState *state);

// ----------------------------------------------------------------------------

#endif // DISPLAY_H_
