#include "stm32f30x.h"
#include "Analog.h"


void analog_init(void) {
	RCC_AHBPeriphClockCmd(ANALOG_RCC_GPIO_BIT, ENABLE);

	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = ANALOG_PIN_MASK;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(ANALOG_PORT, &GPIO_InitStructure);


	/* Configure the ADC clock */
	RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div2);

	RCC_AHBPeriphClockCmd(ANALOG_RCC_ADC_BIT, ENABLE);

	ADC_InitTypeDef           ADC_InitStructure;
	ADC_CommonInitTypeDef     ADC_CommonInitStructure;

    ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;
    ADC_CommonInitStructure.ADC_Clock = ADC_Clock_AsynClkMode;
    ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_Disabled;
    ADC_CommonInitStructure.ADC_DMAMode = ADC_DMAMode_OneShot;
    ADC_CommonInitStructure.ADC_TwoSamplingDelay = 0;
    ADC_CommonInit(ANALOG_ADC, &ADC_CommonInitStructure );

    ADC_InitStructure.ADC_ContinuousConvMode = ADC_ContinuousConvMode_Enable;
    ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b;
    ADC_InitStructure.ADC_ExternalTrigConvEvent = ADC_ExternalTrigConvEvent_0;
    ADC_InitStructure.ADC_ExternalTrigEventEdge = ADC_ExternalTrigEventEdge_None;
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
    ADC_InitStructure.ADC_OverrunMode = ADC_OverrunMode_Disable;
    ADC_InitStructure.ADC_AutoInjMode = ADC_AutoInjec_Disable;
    ADC_InitStructure.ADC_NbrOfRegChannel = 1;
    ADC_Init(ANALOG_ADC, &ADC_InitStructure );

    /* ADC regular channel configuration */
    ADC_RegularChannelConfig(ANALOG_ADC, ANALOG_CHANNEL, 1, ADC_SampleTime_7Cycles5 );

    /* Enable ADC */
    ADC_Cmd( ANALOG_ADC, ENABLE );

//    /* wait for ADRDY */
//    while( !ADC_GetFlagStatus( ANALOG_ADC, ADC_FLAG_RDY ) )
//    	; /* Busy wait */

    /* Start ADC1 Software Conversion */
    ADC_StartConversion( ANALOG_ADC );
}



uint16_t analog_read(void) {
	return ADC_GetConversionValue(ANALOG_ADC);
}
